/* dummy-backend.c generated by valac 0.56.14, the Vala compiler
 * generated from dummy-backend.vala, do not modify */

/*
 * Copyright (C) 2013 Philip Withnall
 * Copyright (C) 2013 Collabora Ltd.
 *
 * This library is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 2.1 of the License, or
 * (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors:
 *       Philip Withnall <philip@tecnocode.co.uk>
 */

#include "folks/folks-dummy.h"
#include <glib.h>
#include <gee.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include "folks/folks.h"
#include <gio/gio.h>
#include "folks-internal.h"

enum  {
	FOLKS_DUMMY_BACKEND_0_PROPERTY,
	FOLKS_DUMMY_BACKEND_IS_PREPARED_PROPERTY,
	FOLKS_DUMMY_BACKEND_IS_QUIESCENT_PROPERTY,
	FOLKS_DUMMY_BACKEND_NAME_PROPERTY,
	FOLKS_DUMMY_BACKEND_PERSONA_STORES_PROPERTY,
	FOLKS_DUMMY_BACKEND_NUM_PROPERTIES
};
static GParamSpec* folks_dummy_backend_properties[FOLKS_DUMMY_BACKEND_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _folks_internal_profile_block_free0(var) ((var == NULL) ? NULL : (var = (folks_internal_profile_block_free (var), NULL)))
typedef struct _FolksDummyBackendPrepareData FolksDummyBackendPrepareData;
typedef struct _FolksDummyBackendUnprepareData FolksDummyBackendUnprepareData;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _FolksDummyBackendPrivate {
	gboolean _is_prepared;
	gboolean _prepare_pending;
	gboolean _is_quiescent;
	GeeHashMap* _all_persona_stores;
	GeeHashMap* _enabled_persona_stores;
	GeeMap* _enabled_persona_stores_ro;
};

struct _FolksDummyBackendPrepareData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksDummyBackend* self;
	FolksInternalProfileBlock* profiling;
	FolksInternalProfileBlock* _tmp0_;
	gboolean _tmp1_;
	FolksInternalProfileBlock* _tmp2_;
	GError* _inner_error0_;
};

struct _FolksDummyBackendUnprepareData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	FolksDummyBackend* self;
	gboolean _tmp0_;
	FolksDummyPersonaStore** enabled_stores;
	GeeHashMap* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GeeCollection* _tmp4_;
	gint _tmp5_;
	gpointer* _tmp6_;
	FolksDummyPersonaStore** _tmp7_;
	gint _tmp7__length1;
	gint enabled_stores_length1;
	gint _enabled_stores_size_;
	FolksDummyPersonaStore** _tmp8_;
	gint _tmp8__length1;
	FolksDummyPersonaStore** persona_store_collection;
	gint persona_store_collection_length1;
	gint _persona_store_collection_size_;
	gint persona_store_it;
	FolksDummyPersonaStore* _tmp9_;
	FolksDummyPersonaStore* persona_store;
	FolksDummyPersonaStore* _tmp10_;
	GError* _inner_error0_;
};

static gint FolksDummyBackend_private_offset;
static gpointer folks_dummy_backend_parent_class = NULL;

static void folks_dummy_backend_real_disable_persona_store (FolksBackend* base,
                                                     FolksPersonaStore* store);
static void _folks_dummy_backend_disable_persona_store (FolksDummyBackend* self,
                                                 FolksPersonaStore* store);
static void folks_dummy_backend_real_enable_persona_store (FolksBackend* base,
                                                    FolksPersonaStore* store);
static void _folks_dummy_backend_enable_persona_store (FolksDummyBackend* self,
                                                FolksDummyPersonaStore* store);
static void folks_dummy_backend_real_set_persona_stores (FolksBackend* base,
                                                  GeeSet* store_ids);
static void _vala_array_add1 (FolksDummyPersonaStore** * array,
                       gint* length,
                       gint* size,
                       FolksDummyPersonaStore* value);
static void _folks_dummy_backend_store_removed_cb (FolksDummyBackend* self,
                                            FolksPersonaStore* store);
static void __folks_dummy_backend_store_removed_cb_folks_persona_store_removed (FolksPersonaStore* _sender,
                                                                         gpointer self);
static void folks_dummy_backend_real_prepare_data_free (gpointer _data);
static void folks_dummy_backend_real_prepare (FolksBackend* base,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_);
static gboolean folks_dummy_backend_real_prepare_co (FolksDummyBackendPrepareData* _data_);
static void folks_dummy_backend_real_unprepare_data_free (gpointer _data);
static void folks_dummy_backend_real_unprepare (FolksBackend* base,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
static gboolean folks_dummy_backend_real_unprepare_co (FolksDummyBackendUnprepareData* _data_);
static GObject * folks_dummy_backend_constructor (GType type,
                                           guint n_construct_properties,
                                           GObjectConstructParam * construct_properties);
static void folks_dummy_backend_finalize (GObject * obj);
static GType folks_dummy_backend_get_type_once (void);
static void _vala_folks_dummy_backend_get_property (GObject * object,
                                             guint property_id,
                                             GValue * value,
                                             GParamSpec * pspec);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static inline gpointer
folks_dummy_backend_get_instance_private (FolksDummyBackend* self)
{
	return G_STRUCT_MEMBER_P (self, FolksDummyBackend_private_offset);
}

/**
   * {@inheritDoc}
   *
   * @since 0.9.7
   */
FolksDummyBackend*
folks_dummy_backend_construct (GType object_type)
{
	FolksDummyBackend * self = NULL;
#line 72 "../backends/dummy/lib/dummy-backend.vala"
	self = (FolksDummyBackend*) g_object_new (object_type, NULL);
#line 70 "../backends/dummy/lib/dummy-backend.vala"
	return self;
#line 173 "dummy-backend.c"
}

FolksDummyBackend*
folks_dummy_backend_new (void)
{
#line 70 "../backends/dummy/lib/dummy-backend.vala"
	return folks_dummy_backend_construct (FOLKS_DUMMY_TYPE_BACKEND);
#line 181 "dummy-backend.c"
}

/**
   * {@inheritDoc}
   *
   * @since 0.9.7
   */
static void
folks_dummy_backend_real_disable_persona_store (FolksBackend* base,
                                                FolksPersonaStore* store)
{
	FolksDummyBackend * self;
#line 129 "../backends/dummy/lib/dummy-backend.vala"
	self = (FolksDummyBackend*) base;
#line 129 "../backends/dummy/lib/dummy-backend.vala"
	g_return_if_fail (store != NULL);
#line 131 "../backends/dummy/lib/dummy-backend.vala"
	_folks_dummy_backend_disable_persona_store (self, store);
#line 200 "dummy-backend.c"
}

/**
   * {@inheritDoc}
   *
   * @since 0.9.7
   */
static void
folks_dummy_backend_real_enable_persona_store (FolksBackend* base,
                                               FolksPersonaStore* store)
{
	FolksDummyBackend * self;
#line 139 "../backends/dummy/lib/dummy-backend.vala"
	self = (FolksDummyBackend*) base;
#line 139 "../backends/dummy/lib/dummy-backend.vala"
	g_return_if_fail (store != NULL);
#line 141 "../backends/dummy/lib/dummy-backend.vala"
	_folks_dummy_backend_enable_persona_store (self, G_TYPE_CHECK_INSTANCE_CAST (store, FOLKS_DUMMY_TYPE_PERSONA_STORE, FolksDummyPersonaStore));
#line 219 "dummy-backend.c"
}

/**
   * {@inheritDoc}
   *
   * @since 0.9.7
   */
static gpointer
_g_object_ref0 (gpointer self)
{
#line 187 "../backends/dummy/lib/dummy-backend.vala"
	return self ? g_object_ref (self) : NULL;
#line 232 "dummy-backend.c"
}

static void
_vala_array_add1 (FolksDummyPersonaStore** * array,
                  gint* length,
                  gint* size,
                  FolksDummyPersonaStore* value)
{
#line 187 "../backends/dummy/lib/dummy-backend.vala"
	if ((*length) == (*size)) {
#line 187 "../backends/dummy/lib/dummy-backend.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 187 "../backends/dummy/lib/dummy-backend.vala"
		*array = g_renew (FolksDummyPersonaStore*, *array, (*size) + 1);
#line 247 "dummy-backend.c"
	}
#line 187 "../backends/dummy/lib/dummy-backend.vala"
	(*array)[(*length)++] = value;
#line 187 "../backends/dummy/lib/dummy-backend.vala"
	(*array)[*length] = NULL;
#line 253 "dummy-backend.c"
}

static void
folks_dummy_backend_real_set_persona_stores (FolksBackend* base,
                                             GeeSet* store_ids)
{
	FolksDummyBackend * self;
	FolksDummyPersonaStore** stores_to_remove = NULL;
	FolksDummyPersonaStore** _tmp21_;
	gint stores_to_remove_length1;
	gint _stores_to_remove_size_;
	FolksDummyPersonaStore** _tmp36_;
	gint _tmp36__length1;
#line 149 "../backends/dummy/lib/dummy-backend.vala"
	self = (FolksDummyBackend*) base;
#line 152 "../backends/dummy/lib/dummy-backend.vala"
	if (store_ids == NULL) {
#line 154 "../backends/dummy/lib/dummy-backend.vala"
		g_object_freeze_notify ((GObject*) self);
#line 273 "dummy-backend.c"
		{
			GeeIterator* _store_it = NULL;
			GeeHashMap* _tmp0_;
			GeeCollection* _tmp1_;
			GeeCollection* _tmp2_;
			GeeCollection* _tmp3_;
			GeeIterator* _tmp4_;
			GeeIterator* _tmp5_;
#line 155 "../backends/dummy/lib/dummy-backend.vala"
			_tmp0_ = self->priv->_all_persona_stores;
#line 155 "../backends/dummy/lib/dummy-backend.vala"
			_tmp1_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp0_);
#line 155 "../backends/dummy/lib/dummy-backend.vala"
			_tmp2_ = _tmp1_;
#line 155 "../backends/dummy/lib/dummy-backend.vala"
			_tmp3_ = _tmp2_;
#line 155 "../backends/dummy/lib/dummy-backend.vala"
			_tmp4_ = gee_iterable_iterator ((GeeIterable*) _tmp3_);
#line 155 "../backends/dummy/lib/dummy-backend.vala"
			_tmp5_ = _tmp4_;
#line 155 "../backends/dummy/lib/dummy-backend.vala"
			_g_object_unref0 (_tmp3_);
#line 155 "../backends/dummy/lib/dummy-backend.vala"
			_store_it = _tmp5_;
#line 155 "../backends/dummy/lib/dummy-backend.vala"
			while (TRUE) {
#line 300 "dummy-backend.c"
				GeeIterator* _tmp6_;
				FolksDummyPersonaStore* store = NULL;
				GeeIterator* _tmp7_;
				gpointer _tmp8_;
				FolksDummyPersonaStore* _tmp9_;
#line 155 "../backends/dummy/lib/dummy-backend.vala"
				_tmp6_ = _store_it;
#line 155 "../backends/dummy/lib/dummy-backend.vala"
				if (!gee_iterator_next (_tmp6_)) {
#line 155 "../backends/dummy/lib/dummy-backend.vala"
					break;
#line 312 "dummy-backend.c"
				}
#line 155 "../backends/dummy/lib/dummy-backend.vala"
				_tmp7_ = _store_it;
#line 155 "../backends/dummy/lib/dummy-backend.vala"
				_tmp8_ = gee_iterator_get (_tmp7_);
#line 155 "../backends/dummy/lib/dummy-backend.vala"
				store = (FolksDummyPersonaStore*) _tmp8_;
#line 157 "../backends/dummy/lib/dummy-backend.vala"
				_tmp9_ = store;
#line 157 "../backends/dummy/lib/dummy-backend.vala"
				_folks_dummy_backend_enable_persona_store (self, _tmp9_);
#line 155 "../backends/dummy/lib/dummy-backend.vala"
				_g_object_unref0 (store);
#line 326 "dummy-backend.c"
			}
#line 155 "../backends/dummy/lib/dummy-backend.vala"
			_g_object_unref0 (_store_it);
#line 330 "dummy-backend.c"
		}
#line 159 "../backends/dummy/lib/dummy-backend.vala"
		g_object_thaw_notify ((GObject*) self);
#line 161 "../backends/dummy/lib/dummy-backend.vala"
		return;
#line 336 "dummy-backend.c"
	}
#line 165 "../backends/dummy/lib/dummy-backend.vala"
	g_object_freeze_notify ((GObject*) self);
#line 340 "dummy-backend.c"
	{
		GeeIterator* _id_it = NULL;
		GeeIterator* _tmp10_;
#line 167 "../backends/dummy/lib/dummy-backend.vala"
		_tmp10_ = gee_iterable_iterator ((GeeIterable*) store_ids);
#line 167 "../backends/dummy/lib/dummy-backend.vala"
		_id_it = _tmp10_;
#line 167 "../backends/dummy/lib/dummy-backend.vala"
		while (TRUE) {
#line 350 "dummy-backend.c"
			GeeIterator* _tmp11_;
			gchar* id = NULL;
			GeeIterator* _tmp12_;
			gpointer _tmp13_;
			GeeHashMap* _tmp14_;
			const gchar* _tmp15_;
#line 167 "../backends/dummy/lib/dummy-backend.vala"
			_tmp11_ = _id_it;
#line 167 "../backends/dummy/lib/dummy-backend.vala"
			if (!gee_iterator_next (_tmp11_)) {
#line 167 "../backends/dummy/lib/dummy-backend.vala"
				break;
#line 363 "dummy-backend.c"
			}
#line 167 "../backends/dummy/lib/dummy-backend.vala"
			_tmp12_ = _id_it;
#line 167 "../backends/dummy/lib/dummy-backend.vala"
			_tmp13_ = gee_iterator_get (_tmp12_);
#line 167 "../backends/dummy/lib/dummy-backend.vala"
			id = (gchar*) _tmp13_;
#line 169 "../backends/dummy/lib/dummy-backend.vala"
			_tmp14_ = self->priv->_enabled_persona_stores;
#line 169 "../backends/dummy/lib/dummy-backend.vala"
			_tmp15_ = id;
#line 169 "../backends/dummy/lib/dummy-backend.vala"
			if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp14_, _tmp15_)) {
#line 377 "dummy-backend.c"
				FolksDummyPersonaStore* store = NULL;
				GeeHashMap* _tmp16_;
				const gchar* _tmp17_;
				gpointer _tmp18_;
				FolksDummyPersonaStore* _tmp19_;
#line 171 "../backends/dummy/lib/dummy-backend.vala"
				_tmp16_ = self->priv->_all_persona_stores;
#line 171 "../backends/dummy/lib/dummy-backend.vala"
				_tmp17_ = id;
#line 171 "../backends/dummy/lib/dummy-backend.vala"
				_tmp18_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp16_, _tmp17_);
#line 171 "../backends/dummy/lib/dummy-backend.vala"
				store = (FolksDummyPersonaStore*) _tmp18_;
#line 172 "../backends/dummy/lib/dummy-backend.vala"
				_tmp19_ = store;
#line 172 "../backends/dummy/lib/dummy-backend.vala"
				if (_tmp19_ != NULL) {
#line 395 "dummy-backend.c"
					FolksDummyPersonaStore* _tmp20_;
#line 174 "../backends/dummy/lib/dummy-backend.vala"
					_tmp20_ = store;
#line 174 "../backends/dummy/lib/dummy-backend.vala"
					_folks_dummy_backend_enable_persona_store (self, _tmp20_);
#line 401 "dummy-backend.c"
				}
#line 169 "../backends/dummy/lib/dummy-backend.vala"
				_g_object_unref0 (store);
#line 405 "dummy-backend.c"
			}
#line 167 "../backends/dummy/lib/dummy-backend.vala"
			_g_free0 (id);
#line 409 "dummy-backend.c"
		}
#line 167 "../backends/dummy/lib/dummy-backend.vala"
		_g_object_unref0 (_id_it);
#line 413 "dummy-backend.c"
	}
#line 181 "../backends/dummy/lib/dummy-backend.vala"
	_tmp21_ = g_new0 (FolksDummyPersonaStore*, 0 + 1);
#line 181 "../backends/dummy/lib/dummy-backend.vala"
	stores_to_remove = _tmp21_;
#line 181 "../backends/dummy/lib/dummy-backend.vala"
	stores_to_remove_length1 = 0;
#line 181 "../backends/dummy/lib/dummy-backend.vala"
	_stores_to_remove_size_ = stores_to_remove_length1;
#line 423 "dummy-backend.c"
	{
		GeeIterator* _store_it = NULL;
		GeeHashMap* _tmp22_;
		GeeCollection* _tmp23_;
		GeeCollection* _tmp24_;
		GeeCollection* _tmp25_;
		GeeIterator* _tmp26_;
		GeeIterator* _tmp27_;
#line 183 "../backends/dummy/lib/dummy-backend.vala"
		_tmp22_ = self->priv->_enabled_persona_stores;
#line 183 "../backends/dummy/lib/dummy-backend.vala"
		_tmp23_ = gee_abstract_map_get_values ((GeeAbstractMap*) _tmp22_);
#line 183 "../backends/dummy/lib/dummy-backend.vala"
		_tmp24_ = _tmp23_;
#line 183 "../backends/dummy/lib/dummy-backend.vala"
		_tmp25_ = _tmp24_;
#line 183 "../backends/dummy/lib/dummy-backend.vala"
		_tmp26_ = gee_iterable_iterator ((GeeIterable*) _tmp25_);
#line 183 "../backends/dummy/lib/dummy-backend.vala"
		_tmp27_ = _tmp26_;
#line 183 "../backends/dummy/lib/dummy-backend.vala"
		_g_object_unref0 (_tmp25_);
#line 183 "../backends/dummy/lib/dummy-backend.vala"
		_store_it = _tmp27_;
#line 183 "../backends/dummy/lib/dummy-backend.vala"
		while (TRUE) {
#line 450 "dummy-backend.c"
			GeeIterator* _tmp28_;
			FolksDummyPersonaStore* store = NULL;
			GeeIterator* _tmp29_;
			gpointer _tmp30_;
			FolksDummyPersonaStore* _tmp31_;
			const gchar* _tmp32_;
			const gchar* _tmp33_;
#line 183 "../backends/dummy/lib/dummy-backend.vala"
			_tmp28_ = _store_it;
#line 183 "../backends/dummy/lib/dummy-backend.vala"
			if (!gee_iterator_next (_tmp28_)) {
#line 183 "../backends/dummy/lib/dummy-backend.vala"
				break;
#line 464 "dummy-backend.c"
			}
#line 183 "../backends/dummy/lib/dummy-backend.vala"
			_tmp29_ = _store_it;
#line 183 "../backends/dummy/lib/dummy-backend.vala"
			_tmp30_ = gee_iterator_get (_tmp29_);
#line 183 "../backends/dummy/lib/dummy-backend.vala"
			store = (FolksDummyPersonaStore*) _tmp30_;
#line 185 "../backends/dummy/lib/dummy-backend.vala"
			_tmp31_ = store;
#line 185 "../backends/dummy/lib/dummy-backend.vala"
			_tmp32_ = folks_persona_store_get_id ((FolksPersonaStore*) _tmp31_);
#line 185 "../backends/dummy/lib/dummy-backend.vala"
			_tmp33_ = _tmp32_;
#line 185 "../backends/dummy/lib/dummy-backend.vala"
			if (!gee_collection_contains ((GeeCollection*) store_ids, _tmp33_)) {
#line 480 "dummy-backend.c"
				FolksDummyPersonaStore* _tmp34_;
				FolksDummyPersonaStore* _tmp35_;
#line 187 "../backends/dummy/lib/dummy-backend.vala"
				_tmp34_ = store;
#line 187 "../backends/dummy/lib/dummy-backend.vala"
				_tmp35_ = _g_object_ref0 (_tmp34_);
#line 187 "../backends/dummy/lib/dummy-backend.vala"
				_vala_array_add1 (&stores_to_remove, &stores_to_remove_length1, &_stores_to_remove_size_, _tmp35_);
#line 489 "dummy-backend.c"
			}
#line 183 "../backends/dummy/lib/dummy-backend.vala"
			_g_object_unref0 (store);
#line 493 "dummy-backend.c"
		}
#line 183 "../backends/dummy/lib/dummy-backend.vala"
		_g_object_unref0 (_store_it);
#line 497 "dummy-backend.c"
	}
#line 191 "../backends/dummy/lib/dummy-backend.vala"
	_tmp36_ = stores_to_remove;
#line 191 "../backends/dummy/lib/dummy-backend.vala"
	_tmp36__length1 = stores_to_remove_length1;
#line 503 "dummy-backend.c"
	{
		FolksDummyPersonaStore** store_collection = NULL;
		gint store_collection_length1 = 0;
		gint _store_collection_size_ = 0;
		gint store_it = 0;
#line 191 "../backends/dummy/lib/dummy-backend.vala"
		store_collection = _tmp36_;
#line 191 "../backends/dummy/lib/dummy-backend.vala"
		store_collection_length1 = _tmp36__length1;
#line 191 "../backends/dummy/lib/dummy-backend.vala"
		for (store_it = 0; store_it < store_collection_length1; store_it = store_it + 1) {
#line 515 "dummy-backend.c"
			FolksDummyPersonaStore* _tmp37_;
			FolksDummyPersonaStore* store = NULL;
#line 191 "../backends/dummy/lib/dummy-backend.vala"
			_tmp37_ = _g_object_ref0 (store_collection[store_it]);
#line 191 "../backends/dummy/lib/dummy-backend.vala"
			store = _tmp37_;
#line 522 "dummy-backend.c"
			{
				FolksDummyPersonaStore* _tmp38_;
#line 193 "../backends/dummy/lib/dummy-backend.vala"
				_tmp38_ = store;
#line 193 "../backends/dummy/lib/dummy-backend.vala"
				_folks_dummy_backend_disable_persona_store (self, (FolksPersonaStore*) _tmp38_);
#line 191 "../backends/dummy/lib/dummy-backend.vala"
				_g_object_unref0 (store);
#line 531 "dummy-backend.c"
			}
		}
	}
#line 196 "../backends/dummy/lib/dummy-backend.vala"
	g_object_thaw_notify ((GObject*) self);
#line 149 "../backends/dummy/lib/dummy-backend.vala"
	stores_to_remove = (_vala_array_free (stores_to_remove, stores_to_remove_length1, (GDestroyNotify) g_object_unref), NULL);
#line 539 "dummy-backend.c"
}

static void
__folks_dummy_backend_store_removed_cb_folks_persona_store_removed (FolksPersonaStore* _sender,
                                                                    gpointer self)
{
#line 207 "../backends/dummy/lib/dummy-backend.vala"
	_folks_dummy_backend_store_removed_cb ((FolksDummyBackend*) self, _sender);
#line 548 "dummy-backend.c"
}

static void
_folks_dummy_backend_enable_persona_store (FolksDummyBackend* self,
                                           FolksDummyPersonaStore* store)
{
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GeeHashMap* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	GeeHashMap* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
#line 199 "../backends/dummy/lib/dummy-backend.vala"
	g_return_if_fail (self != NULL);
#line 199 "../backends/dummy/lib/dummy-backend.vala"
	g_return_if_fail (store != NULL);
#line 201 "../backends/dummy/lib/dummy-backend.vala"
	_tmp0_ = self->priv->_enabled_persona_stores;
#line 201 "../backends/dummy/lib/dummy-backend.vala"
	_tmp1_ = folks_persona_store_get_id ((FolksPersonaStore*) store);
#line 201 "../backends/dummy/lib/dummy-backend.vala"
	_tmp2_ = _tmp1_;
#line 201 "../backends/dummy/lib/dummy-backend.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, _tmp2_)) {
#line 203 "../backends/dummy/lib/dummy-backend.vala"
		return;
#line 578 "dummy-backend.c"
	}
#line 205 "../backends/dummy/lib/dummy-backend.vala"
	_tmp3_ = self->priv->_all_persona_stores;
#line 205 "../backends/dummy/lib/dummy-backend.vala"
	_tmp4_ = folks_persona_store_get_id ((FolksPersonaStore*) store);
#line 205 "../backends/dummy/lib/dummy-backend.vala"
	_tmp5_ = _tmp4_;
#line 205 "../backends/dummy/lib/dummy-backend.vala"
	_vala_assert (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp3_, _tmp5_), "this._all_persona_stores.has_key (store.id)");
#line 207 "../backends/dummy/lib/dummy-backend.vala"
	g_signal_connect_object ((FolksPersonaStore*) store, "removed", (GCallback) __folks_dummy_backend_store_removed_cb_folks_persona_store_removed, self, 0);
#line 209 "../backends/dummy/lib/dummy-backend.vala"
	_tmp6_ = self->priv->_enabled_persona_stores;
#line 209 "../backends/dummy/lib/dummy-backend.vala"
	_tmp7_ = folks_persona_store_get_id ((FolksPersonaStore*) store);
#line 209 "../backends/dummy/lib/dummy-backend.vala"
	_tmp8_ = _tmp7_;
#line 209 "../backends/dummy/lib/dummy-backend.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, _tmp8_, store);
#line 211 "../backends/dummy/lib/dummy-backend.vala"
	g_signal_emit_by_name ((FolksBackend*) self, "persona-store-added", (FolksPersonaStore*) store);
#line 212 "../backends/dummy/lib/dummy-backend.vala"
	g_object_notify ((GObject*) self, "persona-stores");
#line 602 "dummy-backend.c"
}

static void
_folks_dummy_backend_disable_persona_store (FolksDummyBackend* self,
                                            FolksPersonaStore* store)
{
	GeeHashMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GeeHashMap* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
	guint _tmp6_;
#line 215 "../backends/dummy/lib/dummy-backend.vala"
	g_return_if_fail (self != NULL);
#line 215 "../backends/dummy/lib/dummy-backend.vala"
	g_return_if_fail (store != NULL);
#line 217 "../backends/dummy/lib/dummy-backend.vala"
	_tmp0_ = self->priv->_enabled_persona_stores;
#line 217 "../backends/dummy/lib/dummy-backend.vala"
	_tmp1_ = folks_persona_store_get_id (store);
#line 217 "../backends/dummy/lib/dummy-backend.vala"
	_tmp2_ = _tmp1_;
#line 217 "../backends/dummy/lib/dummy-backend.vala"
	if (!gee_abstract_map_unset ((GeeAbstractMap*) _tmp0_, _tmp2_, NULL)) {
#line 219 "../backends/dummy/lib/dummy-backend.vala"
		return;
#line 630 "dummy-backend.c"
	}
#line 221 "../backends/dummy/lib/dummy-backend.vala"
	_tmp3_ = self->priv->_all_persona_stores;
#line 221 "../backends/dummy/lib/dummy-backend.vala"
	_tmp4_ = folks_persona_store_get_id (store);
#line 221 "../backends/dummy/lib/dummy-backend.vala"
	_tmp5_ = _tmp4_;
#line 221 "../backends/dummy/lib/dummy-backend.vala"
	_vala_assert (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp3_, _tmp5_), "this._all_persona_stores.has_key (store.id)");
#line 223 "../backends/dummy/lib/dummy-backend.vala"
	g_signal_emit_by_name ((FolksBackend*) self, "persona-store-removed", store);
#line 224 "../backends/dummy/lib/dummy-backend.vala"
	g_object_notify ((GObject*) self, "persona-stores");
#line 226 "../backends/dummy/lib/dummy-backend.vala"
	g_signal_parse_name ("removed", FOLKS_TYPE_PERSONA_STORE, &_tmp6_, NULL, FALSE);
#line 226 "../backends/dummy/lib/dummy-backend.vala"
	g_signal_handlers_disconnect_matched (store, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) __folks_dummy_backend_store_removed_cb_folks_persona_store_removed, self);
#line 648 "dummy-backend.c"
}

static void
_folks_dummy_backend_store_removed_cb (FolksDummyBackend* self,
                                       FolksPersonaStore* store)
{
#line 229 "../backends/dummy/lib/dummy-backend.vala"
	g_return_if_fail (self != NULL);
#line 229 "../backends/dummy/lib/dummy-backend.vala"
	g_return_if_fail (store != NULL);
#line 231 "../backends/dummy/lib/dummy-backend.vala"
	_folks_dummy_backend_disable_persona_store (self, store);
#line 661 "dummy-backend.c"
}

static void
folks_dummy_backend_real_prepare_data_free (gpointer _data)
{
	FolksDummyBackendPrepareData* _data_;
	_data_ = _data;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	_g_object_unref0 (_data_->self);
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	g_slice_free (FolksDummyBackendPrepareData, _data_);
#line 673 "dummy-backend.c"
}

static void
folks_dummy_backend_real_prepare (FolksBackend* base,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	FolksDummyBackend * self;
	FolksDummyBackendPrepareData* _data_;
	FolksDummyBackend* _tmp0_;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	self = (FolksDummyBackend*) base;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	_data_ = g_slice_new0 (FolksDummyBackendPrepareData);
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_dummy_backend_real_prepare_data_free);
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	_data_->self = _tmp0_;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	folks_dummy_backend_real_prepare_co (_data_);
#line 698 "dummy-backend.c"
}

static void
folks_dummy_backend_prepare_finish (FolksBackend* base,
                                    GAsyncResult* _res_,
                                    GError** error)
{
	FolksDummyBackendPrepareData* _data_;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	if (NULL == _data_) {
#line 55 "../backends/dummy/lib/dummy-backend.vala"
		return;
#line 713 "dummy-backend.c"
	}
}

/**
   * {@inheritDoc}
   *
   * @since 0.9.7
   */
static gboolean
folks_dummy_backend_real_prepare_co (FolksDummyBackendPrepareData* _data_)
{
#line 239 "../backends/dummy/lib/dummy-backend.vala"
	switch (_data_->_state_) {
#line 239 "../backends/dummy/lib/dummy-backend.vala"
		case 0:
#line 729 "dummy-backend.c"
		goto _state_0;
		default:
#line 239 "../backends/dummy/lib/dummy-backend.vala"
		g_assert_not_reached ();
#line 734 "dummy-backend.c"
	}
	_state_0:
#line 241 "../backends/dummy/lib/dummy-backend.vala"
	_data_->_tmp0_ = folks_internal_profiling_start ("preparing Dummy.Backend", NULL);
#line 241 "../backends/dummy/lib/dummy-backend.vala"
	_data_->profiling = _data_->_tmp0_;
#line 243 "../backends/dummy/lib/dummy-backend.vala"
	if (_data_->self->priv->_is_prepared) {
#line 243 "../backends/dummy/lib/dummy-backend.vala"
		_data_->_tmp1_ = TRUE;
#line 745 "dummy-backend.c"
	} else {
#line 243 "../backends/dummy/lib/dummy-backend.vala"
		_data_->_tmp1_ = _data_->self->priv->_prepare_pending;
#line 749 "dummy-backend.c"
	}
#line 243 "../backends/dummy/lib/dummy-backend.vala"
	if (_data_->_tmp1_) {
#line 245 "../backends/dummy/lib/dummy-backend.vala"
		_folks_internal_profile_block_free0 (_data_->profiling);
#line 245 "../backends/dummy/lib/dummy-backend.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 245 "../backends/dummy/lib/dummy-backend.vala"
		if (_data_->_state_ != 0) {
#line 245 "../backends/dummy/lib/dummy-backend.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 245 "../backends/dummy/lib/dummy-backend.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 763 "dummy-backend.c"
			}
		}
#line 245 "../backends/dummy/lib/dummy-backend.vala"
		g_object_unref (_data_->_async_result);
#line 245 "../backends/dummy/lib/dummy-backend.vala"
		return FALSE;
#line 770 "dummy-backend.c"
	}
	{
#line 250 "../backends/dummy/lib/dummy-backend.vala"
		_data_->self->priv->_prepare_pending = TRUE;
#line 251 "../backends/dummy/lib/dummy-backend.vala"
		g_object_freeze_notify ((GObject*) _data_->self);
#line 253 "../backends/dummy/lib/dummy-backend.vala"
		_data_->self->priv->_is_prepared = TRUE;
#line 254 "../backends/dummy/lib/dummy-backend.vala"
		g_object_notify ((GObject*) _data_->self, "is-prepared");
#line 256 "../backends/dummy/lib/dummy-backend.vala"
		_data_->self->priv->_is_quiescent = TRUE;
#line 257 "../backends/dummy/lib/dummy-backend.vala"
		g_object_notify ((GObject*) _data_->self, "is-quiescent");
#line 785 "dummy-backend.c"
	}
	__finally0:
	{
#line 261 "../backends/dummy/lib/dummy-backend.vala"
		g_object_thaw_notify ((GObject*) _data_->self);
#line 262 "../backends/dummy/lib/dummy-backend.vala"
		_data_->self->priv->_prepare_pending = FALSE;
#line 793 "dummy-backend.c"
	}
#line 248 "../backends/dummy/lib/dummy-backend.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 248 "../backends/dummy/lib/dummy-backend.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 248 "../backends/dummy/lib/dummy-backend.vala"
		_folks_internal_profile_block_free0 (_data_->profiling);
#line 248 "../backends/dummy/lib/dummy-backend.vala"
		g_object_unref (_data_->_async_result);
#line 248 "../backends/dummy/lib/dummy-backend.vala"
		return FALSE;
#line 805 "dummy-backend.c"
	}
#line 265 "../backends/dummy/lib/dummy-backend.vala"
	_data_->_tmp2_ = _data_->profiling;
#line 265 "../backends/dummy/lib/dummy-backend.vala"
	_data_->profiling = NULL;
#line 265 "../backends/dummy/lib/dummy-backend.vala"
	folks_internal_profiling_end (_data_->_tmp2_);
#line 239 "../backends/dummy/lib/dummy-backend.vala"
	_folks_internal_profile_block_free0 (_data_->profiling);
#line 239 "../backends/dummy/lib/dummy-backend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 239 "../backends/dummy/lib/dummy-backend.vala"
	if (_data_->_state_ != 0) {
#line 239 "../backends/dummy/lib/dummy-backend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 239 "../backends/dummy/lib/dummy-backend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 823 "dummy-backend.c"
		}
	}
#line 239 "../backends/dummy/lib/dummy-backend.vala"
	g_object_unref (_data_->_async_result);
#line 239 "../backends/dummy/lib/dummy-backend.vala"
	return FALSE;
#line 830 "dummy-backend.c"
}

static void
folks_dummy_backend_real_unprepare_data_free (gpointer _data)
{
	FolksDummyBackendUnprepareData* _data_;
	_data_ = _data;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	_g_object_unref0 (_data_->self);
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	g_slice_free (FolksDummyBackendUnprepareData, _data_);
#line 842 "dummy-backend.c"
}

static void
folks_dummy_backend_real_unprepare (FolksBackend* base,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	FolksDummyBackend * self;
	FolksDummyBackendUnprepareData* _data_;
	FolksDummyBackend* _tmp0_;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	self = (FolksDummyBackend*) base;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	_data_ = g_slice_new0 (FolksDummyBackendUnprepareData);
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	g_task_set_task_data (_data_->_async_result, _data_, folks_dummy_backend_real_unprepare_data_free);
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	_data_->self = _tmp0_;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	folks_dummy_backend_real_unprepare_co (_data_);
#line 867 "dummy-backend.c"
}

static void
folks_dummy_backend_unprepare_finish (FolksBackend* base,
                                      GAsyncResult* _res_,
                                      GError** error)
{
	FolksDummyBackendUnprepareData* _data_;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	if (NULL == _data_) {
#line 55 "../backends/dummy/lib/dummy-backend.vala"
		return;
#line 882 "dummy-backend.c"
	}
}

/**
   * {@inheritDoc}
   *
   * @since 0.9.7
   */
static gboolean
folks_dummy_backend_real_unprepare_co (FolksDummyBackendUnprepareData* _data_)
{
#line 273 "../backends/dummy/lib/dummy-backend.vala"
	switch (_data_->_state_) {
#line 273 "../backends/dummy/lib/dummy-backend.vala"
		case 0:
#line 898 "dummy-backend.c"
		goto _state_0;
		default:
#line 273 "../backends/dummy/lib/dummy-backend.vala"
		g_assert_not_reached ();
#line 903 "dummy-backend.c"
	}
	_state_0:
#line 275 "../backends/dummy/lib/dummy-backend.vala"
	if (!_data_->self->priv->_is_prepared) {
#line 275 "../backends/dummy/lib/dummy-backend.vala"
		_data_->_tmp0_ = TRUE;
#line 910 "dummy-backend.c"
	} else {
#line 275 "../backends/dummy/lib/dummy-backend.vala"
		_data_->_tmp0_ = _data_->self->priv->_prepare_pending;
#line 914 "dummy-backend.c"
	}
#line 275 "../backends/dummy/lib/dummy-backend.vala"
	if (_data_->_tmp0_) {
#line 277 "../backends/dummy/lib/dummy-backend.vala"
		g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 277 "../backends/dummy/lib/dummy-backend.vala"
		if (_data_->_state_ != 0) {
#line 277 "../backends/dummy/lib/dummy-backend.vala"
			while (!g_task_get_completed (_data_->_async_result)) {
#line 277 "../backends/dummy/lib/dummy-backend.vala"
				g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 926 "dummy-backend.c"
			}
		}
#line 277 "../backends/dummy/lib/dummy-backend.vala"
		g_object_unref (_data_->_async_result);
#line 277 "../backends/dummy/lib/dummy-backend.vala"
		return FALSE;
#line 933 "dummy-backend.c"
	}
	{
#line 282 "../backends/dummy/lib/dummy-backend.vala"
		_data_->self->priv->_prepare_pending = TRUE;
#line 283 "../backends/dummy/lib/dummy-backend.vala"
		g_object_freeze_notify ((GObject*) _data_->self);
#line 285 "../backends/dummy/lib/dummy-backend.vala"
		_data_->_tmp1_ = _data_->self->priv->_enabled_persona_stores;
#line 285 "../backends/dummy/lib/dummy-backend.vala"
		_data_->_tmp2_ = gee_abstract_map_get_values ((GeeAbstractMap*) _data_->_tmp1_);
#line 285 "../backends/dummy/lib/dummy-backend.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 285 "../backends/dummy/lib/dummy-backend.vala"
		_data_->_tmp4_ = _data_->_tmp3_;
#line 285 "../backends/dummy/lib/dummy-backend.vala"
		_data_->_tmp5_ = 0;
#line 285 "../backends/dummy/lib/dummy-backend.vala"
		_data_->_tmp6_ = gee_collection_to_array (_data_->_tmp4_, &_data_->_tmp5_);
#line 285 "../backends/dummy/lib/dummy-backend.vala"
		_data_->_tmp7_ = _data_->_tmp6_;
#line 285 "../backends/dummy/lib/dummy-backend.vala"
		_data_->_tmp7__length1 = _data_->_tmp5_;
#line 285 "../backends/dummy/lib/dummy-backend.vala"
		_g_object_unref0 (_data_->_tmp4_);
#line 285 "../backends/dummy/lib/dummy-backend.vala"
		_data_->enabled_stores = _data_->_tmp7_;
#line 285 "../backends/dummy/lib/dummy-backend.vala"
		_data_->enabled_stores_length1 = _data_->_tmp7__length1;
#line 285 "../backends/dummy/lib/dummy-backend.vala"
		_data_->_enabled_stores_size_ = _data_->enabled_stores_length1;
#line 286 "../backends/dummy/lib/dummy-backend.vala"
		_data_->_tmp8_ = _data_->enabled_stores;
#line 286 "../backends/dummy/lib/dummy-backend.vala"
		_data_->_tmp8__length1 = _data_->enabled_stores_length1;
#line 968 "dummy-backend.c"
		{
#line 286 "../backends/dummy/lib/dummy-backend.vala"
			_data_->persona_store_collection_length1 = 0;
#line 286 "../backends/dummy/lib/dummy-backend.vala"
			_data_->_persona_store_collection_size_ = 0;
#line 286 "../backends/dummy/lib/dummy-backend.vala"
			_data_->persona_store_collection = _data_->_tmp8_;
#line 286 "../backends/dummy/lib/dummy-backend.vala"
			_data_->persona_store_collection_length1 = _data_->_tmp8__length1;
#line 286 "../backends/dummy/lib/dummy-backend.vala"
			for (_data_->persona_store_it = 0; _data_->persona_store_it < _data_->persona_store_collection_length1; _data_->persona_store_it = _data_->persona_store_it + 1) {
#line 286 "../backends/dummy/lib/dummy-backend.vala"
				_data_->_tmp9_ = _g_object_ref0 (_data_->persona_store_collection[_data_->persona_store_it]);
#line 286 "../backends/dummy/lib/dummy-backend.vala"
				_data_->persona_store = _data_->_tmp9_;
#line 984 "dummy-backend.c"
				{
#line 288 "../backends/dummy/lib/dummy-backend.vala"
					_data_->_tmp10_ = _data_->persona_store;
#line 288 "../backends/dummy/lib/dummy-backend.vala"
					_folks_dummy_backend_disable_persona_store (_data_->self, (FolksPersonaStore*) _data_->_tmp10_);
#line 286 "../backends/dummy/lib/dummy-backend.vala"
					_g_object_unref0 (_data_->persona_store);
#line 992 "dummy-backend.c"
				}
			}
		}
#line 291 "../backends/dummy/lib/dummy-backend.vala"
		_data_->self->priv->_is_quiescent = FALSE;
#line 292 "../backends/dummy/lib/dummy-backend.vala"
		g_object_notify ((GObject*) _data_->self, "is-quiescent");
#line 294 "../backends/dummy/lib/dummy-backend.vala"
		_data_->self->priv->_is_prepared = FALSE;
#line 295 "../backends/dummy/lib/dummy-backend.vala"
		g_object_notify ((GObject*) _data_->self, "is-prepared");
#line 280 "../backends/dummy/lib/dummy-backend.vala"
		_data_->enabled_stores = (_vala_array_free (_data_->enabled_stores, _data_->enabled_stores_length1, (GDestroyNotify) g_object_unref), NULL);
#line 1006 "dummy-backend.c"
	}
	__finally0:
	{
#line 299 "../backends/dummy/lib/dummy-backend.vala"
		g_object_thaw_notify ((GObject*) _data_->self);
#line 300 "../backends/dummy/lib/dummy-backend.vala"
		_data_->self->priv->_prepare_pending = FALSE;
#line 1014 "dummy-backend.c"
	}
#line 280 "../backends/dummy/lib/dummy-backend.vala"
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
#line 280 "../backends/dummy/lib/dummy-backend.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error0_);
#line 280 "../backends/dummy/lib/dummy-backend.vala"
		g_object_unref (_data_->_async_result);
#line 280 "../backends/dummy/lib/dummy-backend.vala"
		return FALSE;
#line 1024 "dummy-backend.c"
	}
#line 273 "../backends/dummy/lib/dummy-backend.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 273 "../backends/dummy/lib/dummy-backend.vala"
	if (_data_->_state_ != 0) {
#line 273 "../backends/dummy/lib/dummy-backend.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 273 "../backends/dummy/lib/dummy-backend.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1034 "dummy-backend.c"
		}
	}
#line 273 "../backends/dummy/lib/dummy-backend.vala"
	g_object_unref (_data_->_async_result);
#line 273 "../backends/dummy/lib/dummy-backend.vala"
	return FALSE;
#line 1041 "dummy-backend.c"
}

/**
   * Register and enable some {@link FolksDummy.PersonaStore}s.
   *
   * For each of the persona stores in ``stores``, register it with this
   * backend. If ``enable_stores`` is ``true``, added stores will also be
   * enabled, emitting {@link Folks.Backend.persona_store_added} for each
   * newly-enabled store. After all addition signals are emitted, a change
   * notification for {@link Folks.Backend.persona_stores} will be emitted (but
   * only if at least one addition signal is emitted).
   *
   * Persona stores are identified by their {@link Folks.PersonaStore.id}; if a
   * store in ``stores`` has the same ID as a store previously registered
   * through this method, the duplicate will be ignored (so
   * {@link Folks.Backend.persona_store_added} won't be emitted for that store).
   *
   * Persona stores must be instances of {@link FolksDummy.PersonaStore} or
   * subclasses of it, allowing for different persona store implementations to
   * be tested.
   *
   * @param stores set of persona stores to register
   * @param enable_stores whether to automatically enable the stores
   * @since 0.9.7
   */
void
folks_dummy_backend_register_persona_stores (FolksDummyBackend* self,
                                             GeeSet* stores,
                                             gboolean enable_stores)
{
#line 335 "../backends/dummy/lib/dummy-backend.vala"
	g_return_if_fail (self != NULL);
#line 335 "../backends/dummy/lib/dummy-backend.vala"
	g_return_if_fail (stores != NULL);
#line 338 "../backends/dummy/lib/dummy-backend.vala"
	g_object_freeze_notify ((GObject*) self);
#line 1078 "dummy-backend.c"
	{
		GeeIterator* _store_it = NULL;
		GeeIterator* _tmp0_;
#line 340 "../backends/dummy/lib/dummy-backend.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) stores);
#line 340 "../backends/dummy/lib/dummy-backend.vala"
		_store_it = _tmp0_;
#line 340 "../backends/dummy/lib/dummy-backend.vala"
		while (TRUE) {
#line 1088 "dummy-backend.c"
			GeeIterator* _tmp1_;
			FolksDummyPersonaStore* store = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			FolksDummyPersonaStore* _tmp4_;
			GeeHashMap* _tmp5_;
			FolksDummyPersonaStore* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			GeeHashMap* _tmp9_;
			FolksDummyPersonaStore* _tmp10_;
			const gchar* _tmp11_;
			const gchar* _tmp12_;
			FolksDummyPersonaStore* _tmp13_;
#line 340 "../backends/dummy/lib/dummy-backend.vala"
			_tmp1_ = _store_it;
#line 340 "../backends/dummy/lib/dummy-backend.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 340 "../backends/dummy/lib/dummy-backend.vala"
				break;
#line 1109 "dummy-backend.c"
			}
#line 340 "../backends/dummy/lib/dummy-backend.vala"
			_tmp2_ = _store_it;
#line 340 "../backends/dummy/lib/dummy-backend.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 340 "../backends/dummy/lib/dummy-backend.vala"
			store = (FolksDummyPersonaStore*) _tmp3_;
#line 342 "../backends/dummy/lib/dummy-backend.vala"
			_tmp4_ = store;
#line 342 "../backends/dummy/lib/dummy-backend.vala"
			_vala_assert (FOLKS_DUMMY_IS_PERSONA_STORE (_tmp4_), "store is FolksDummy.PersonaStore");
#line 344 "../backends/dummy/lib/dummy-backend.vala"
			_tmp5_ = self->priv->_all_persona_stores;
#line 344 "../backends/dummy/lib/dummy-backend.vala"
			_tmp6_ = store;
#line 344 "../backends/dummy/lib/dummy-backend.vala"
			_tmp7_ = folks_persona_store_get_id ((FolksPersonaStore*) _tmp6_);
#line 344 "../backends/dummy/lib/dummy-backend.vala"
			_tmp8_ = _tmp7_;
#line 344 "../backends/dummy/lib/dummy-backend.vala"
			if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp5_, _tmp8_)) {
#line 346 "../backends/dummy/lib/dummy-backend.vala"
				_g_object_unref0 (store);
#line 346 "../backends/dummy/lib/dummy-backend.vala"
				continue;
#line 1135 "dummy-backend.c"
			}
#line 349 "../backends/dummy/lib/dummy-backend.vala"
			_tmp9_ = self->priv->_all_persona_stores;
#line 349 "../backends/dummy/lib/dummy-backend.vala"
			_tmp10_ = store;
#line 349 "../backends/dummy/lib/dummy-backend.vala"
			_tmp11_ = folks_persona_store_get_id ((FolksPersonaStore*) _tmp10_);
#line 349 "../backends/dummy/lib/dummy-backend.vala"
			_tmp12_ = _tmp11_;
#line 349 "../backends/dummy/lib/dummy-backend.vala"
			_tmp13_ = store;
#line 349 "../backends/dummy/lib/dummy-backend.vala"
			gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, _tmp12_, _tmp13_);
#line 351 "../backends/dummy/lib/dummy-backend.vala"
			if (enable_stores == TRUE) {
#line 1151 "dummy-backend.c"
				FolksDummyPersonaStore* _tmp14_;
#line 353 "../backends/dummy/lib/dummy-backend.vala"
				_tmp14_ = store;
#line 353 "../backends/dummy/lib/dummy-backend.vala"
				_folks_dummy_backend_enable_persona_store (self, _tmp14_);
#line 1157 "dummy-backend.c"
			}
#line 340 "../backends/dummy/lib/dummy-backend.vala"
			_g_object_unref0 (store);
#line 1161 "dummy-backend.c"
		}
#line 340 "../backends/dummy/lib/dummy-backend.vala"
		_g_object_unref0 (_store_it);
#line 1165 "dummy-backend.c"
	}
#line 357 "../backends/dummy/lib/dummy-backend.vala"
	g_object_thaw_notify ((GObject*) self);
#line 1169 "dummy-backend.c"
}

/**
   * Disable and unregister some {@link FolksDummy.PersonaStore}s.
   *
   * For each of the persona stores in ``stores``, disable it (if it was
   * enabled) and unregister it from the backend so that it cannot be re-enabled
   * using {@link Folks.Backend.enable_persona_store} or
   * {@link Folks.Backend.set_persona_stores}.
   *
   * {@link Folks.Backend.persona_store_removed} will be emitted for all persona
   * stores in ``stores`` which were previously enabled. After all removal
   * signals are emitted, a change notification for
   * {@link Folks.Backend.persona_stores} will be emitted (but only if at least
   * one removal signal is emitted).
   *
   * @since 0.9.7
   */
void
folks_dummy_backend_unregister_persona_stores (FolksDummyBackend* self,
                                               GeeSet* stores)
{
#line 376 "../backends/dummy/lib/dummy-backend.vala"
	g_return_if_fail (self != NULL);
#line 376 "../backends/dummy/lib/dummy-backend.vala"
	g_return_if_fail (stores != NULL);
#line 378 "../backends/dummy/lib/dummy-backend.vala"
	g_object_freeze_notify ((GObject*) self);
#line 1198 "dummy-backend.c"
	{
		GeeIterator* _store_it = NULL;
		GeeIterator* _tmp0_;
#line 380 "../backends/dummy/lib/dummy-backend.vala"
		_tmp0_ = gee_iterable_iterator ((GeeIterable*) stores);
#line 380 "../backends/dummy/lib/dummy-backend.vala"
		_store_it = _tmp0_;
#line 380 "../backends/dummy/lib/dummy-backend.vala"
		while (TRUE) {
#line 1208 "dummy-backend.c"
			GeeIterator* _tmp1_;
			FolksDummyPersonaStore* store = NULL;
			GeeIterator* _tmp2_;
			gpointer _tmp3_;
			FolksDummyPersonaStore* _tmp4_;
			GeeHashMap* _tmp5_;
			FolksDummyPersonaStore* _tmp6_;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			FolksDummyPersonaStore* _tmp9_;
			GeeHashMap* _tmp10_;
			FolksDummyPersonaStore* _tmp11_;
			const gchar* _tmp12_;
			const gchar* _tmp13_;
#line 380 "../backends/dummy/lib/dummy-backend.vala"
			_tmp1_ = _store_it;
#line 380 "../backends/dummy/lib/dummy-backend.vala"
			if (!gee_iterator_next (_tmp1_)) {
#line 380 "../backends/dummy/lib/dummy-backend.vala"
				break;
#line 1229 "dummy-backend.c"
			}
#line 380 "../backends/dummy/lib/dummy-backend.vala"
			_tmp2_ = _store_it;
#line 380 "../backends/dummy/lib/dummy-backend.vala"
			_tmp3_ = gee_iterator_get (_tmp2_);
#line 380 "../backends/dummy/lib/dummy-backend.vala"
			store = (FolksDummyPersonaStore*) _tmp3_;
#line 382 "../backends/dummy/lib/dummy-backend.vala"
			_tmp4_ = store;
#line 382 "../backends/dummy/lib/dummy-backend.vala"
			_vala_assert (FOLKS_DUMMY_IS_PERSONA_STORE (_tmp4_), "store is FolksDummy.PersonaStore");
#line 384 "../backends/dummy/lib/dummy-backend.vala"
			_tmp5_ = self->priv->_all_persona_stores;
#line 384 "../backends/dummy/lib/dummy-backend.vala"
			_tmp6_ = store;
#line 384 "../backends/dummy/lib/dummy-backend.vala"
			_tmp7_ = folks_persona_store_get_id ((FolksPersonaStore*) _tmp6_);
#line 384 "../backends/dummy/lib/dummy-backend.vala"
			_tmp8_ = _tmp7_;
#line 384 "../backends/dummy/lib/dummy-backend.vala"
			if (!gee_abstract_map_has_key ((GeeAbstractMap*) _tmp5_, _tmp8_)) {
#line 386 "../backends/dummy/lib/dummy-backend.vala"
				_g_object_unref0 (store);
#line 386 "../backends/dummy/lib/dummy-backend.vala"
				continue;
#line 1255 "dummy-backend.c"
			}
#line 389 "../backends/dummy/lib/dummy-backend.vala"
			_tmp9_ = store;
#line 389 "../backends/dummy/lib/dummy-backend.vala"
			_folks_dummy_backend_disable_persona_store (self, (FolksPersonaStore*) _tmp9_);
#line 390 "../backends/dummy/lib/dummy-backend.vala"
			_tmp10_ = self->priv->_all_persona_stores;
#line 390 "../backends/dummy/lib/dummy-backend.vala"
			_tmp11_ = store;
#line 390 "../backends/dummy/lib/dummy-backend.vala"
			_tmp12_ = folks_persona_store_get_id ((FolksPersonaStore*) _tmp11_);
#line 390 "../backends/dummy/lib/dummy-backend.vala"
			_tmp13_ = _tmp12_;
#line 390 "../backends/dummy/lib/dummy-backend.vala"
			gee_abstract_map_unset ((GeeAbstractMap*) _tmp10_, _tmp13_, NULL);
#line 380 "../backends/dummy/lib/dummy-backend.vala"
			_g_object_unref0 (store);
#line 1273 "dummy-backend.c"
		}
#line 380 "../backends/dummy/lib/dummy-backend.vala"
		_g_object_unref0 (_store_it);
#line 1277 "dummy-backend.c"
	}
#line 393 "../backends/dummy/lib/dummy-backend.vala"
	g_object_thaw_notify ((GObject*) self);
#line 1281 "dummy-backend.c"
}

static gboolean
folks_dummy_backend_real_get_is_prepared (FolksBackend* base)
{
	gboolean result;
	FolksDummyBackend* self;
#line 92 "../backends/dummy/lib/dummy-backend.vala"
	self = (FolksDummyBackend*) base;
#line 92 "../backends/dummy/lib/dummy-backend.vala"
	result = self->priv->_is_prepared;
#line 92 "../backends/dummy/lib/dummy-backend.vala"
	return result;
#line 1295 "dummy-backend.c"
}

static gboolean
folks_dummy_backend_real_get_is_quiescent (FolksBackend* base)
{
	gboolean result;
	FolksDummyBackend* self;
#line 104 "../backends/dummy/lib/dummy-backend.vala"
	self = (FolksDummyBackend*) base;
#line 104 "../backends/dummy/lib/dummy-backend.vala"
	result = self->priv->_is_quiescent;
#line 104 "../backends/dummy/lib/dummy-backend.vala"
	return result;
#line 1309 "dummy-backend.c"
}

static const gchar*
folks_dummy_backend_real_get_name (FolksBackend* base)
{
	const gchar* result;
	FolksDummyBackend* self;
#line 112 "../backends/dummy/lib/dummy-backend.vala"
	self = (FolksDummyBackend*) base;
#line 112 "../backends/dummy/lib/dummy-backend.vala"
	result = BACKEND_NAME;
#line 112 "../backends/dummy/lib/dummy-backend.vala"
	return result;
#line 1323 "dummy-backend.c"
}

static GeeMap*
folks_dummy_backend_real_get_persona_stores (FolksBackend* base)
{
	GeeMap* result;
	FolksDummyBackend* self;
	GeeMap* _tmp0_;
#line 121 "../backends/dummy/lib/dummy-backend.vala"
	self = (FolksDummyBackend*) base;
#line 121 "../backends/dummy/lib/dummy-backend.vala"
	_tmp0_ = self->priv->_enabled_persona_stores_ro;
#line 121 "../backends/dummy/lib/dummy-backend.vala"
	result = _tmp0_;
#line 121 "../backends/dummy/lib/dummy-backend.vala"
	return result;
#line 1340 "dummy-backend.c"
}

static GObject *
folks_dummy_backend_constructor (GType type,
                                 guint n_construct_properties,
                                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	FolksDummyBackend * self;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	GeeMap* _tmp3_;
	GeeMap* _tmp4_;
#line 75 "../backends/dummy/lib/dummy-backend.vala"
	parent_class = G_OBJECT_CLASS (folks_dummy_backend_parent_class);
#line 75 "../backends/dummy/lib/dummy-backend.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 75 "../backends/dummy/lib/dummy-backend.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOLKS_DUMMY_TYPE_BACKEND, FolksDummyBackend);
#line 77 "../backends/dummy/lib/dummy-backend.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, FOLKS_DUMMY_TYPE_PERSONA_STORE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 77 "../backends/dummy/lib/dummy-backend.vala"
	_g_object_unref0 (self->priv->_all_persona_stores);
#line 77 "../backends/dummy/lib/dummy-backend.vala"
	self->priv->_all_persona_stores = _tmp0_;
#line 78 "../backends/dummy/lib/dummy-backend.vala"
	_tmp1_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, FOLKS_DUMMY_TYPE_PERSONA_STORE, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 78 "../backends/dummy/lib/dummy-backend.vala"
	_g_object_unref0 (self->priv->_enabled_persona_stores);
#line 78 "../backends/dummy/lib/dummy-backend.vala"
	self->priv->_enabled_persona_stores = _tmp1_;
#line 79 "../backends/dummy/lib/dummy-backend.vala"
	_tmp2_ = self->priv->_enabled_persona_stores;
#line 79 "../backends/dummy/lib/dummy-backend.vala"
	_tmp3_ = gee_abstract_map_get_read_only_view ((GeeAbstractMap*) _tmp2_);
#line 79 "../backends/dummy/lib/dummy-backend.vala"
	_tmp4_ = _tmp3_;
#line 79 "../backends/dummy/lib/dummy-backend.vala"
	_g_object_unref0 (self->priv->_enabled_persona_stores_ro);
#line 79 "../backends/dummy/lib/dummy-backend.vala"
	self->priv->_enabled_persona_stores_ro = _tmp4_;
#line 75 "../backends/dummy/lib/dummy-backend.vala"
	return obj;
#line 1386 "dummy-backend.c"
}

static void
folks_dummy_backend_class_init (FolksDummyBackendClass * klass,
                                gpointer klass_data)
{
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	folks_dummy_backend_parent_class = g_type_class_peek_parent (klass);
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	g_type_class_adjust_private_offset (klass, &FolksDummyBackend_private_offset);
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	((FolksBackendClass *) klass)->disable_persona_store = (void (*) (FolksBackend*, FolksPersonaStore*)) folks_dummy_backend_real_disable_persona_store;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	((FolksBackendClass *) klass)->enable_persona_store = (void (*) (FolksBackend*, FolksPersonaStore*)) folks_dummy_backend_real_enable_persona_store;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	((FolksBackendClass *) klass)->set_persona_stores = (void (*) (FolksBackend*, GeeSet*)) folks_dummy_backend_real_set_persona_stores;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	((FolksBackendClass *) klass)->prepare = (void (*) (FolksBackend*, GAsyncReadyCallback, gpointer)) folks_dummy_backend_real_prepare;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	((FolksBackendClass *) klass)->prepare_finish = (void (*) (FolksBackend*, GAsyncResult*, GError**)) folks_dummy_backend_prepare_finish;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	((FolksBackendClass *) klass)->unprepare = (void (*) (FolksBackend*, GAsyncReadyCallback, gpointer)) folks_dummy_backend_real_unprepare;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	((FolksBackendClass *) klass)->unprepare_finish = (void (*) (FolksBackend*, GAsyncResult*, GError**)) folks_dummy_backend_unprepare_finish;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	FOLKS_BACKEND_CLASS (klass)->get_is_prepared = (gboolean (*) (FolksBackend*)) folks_dummy_backend_real_get_is_prepared;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	FOLKS_BACKEND_CLASS (klass)->get_is_quiescent = (gboolean (*) (FolksBackend*)) folks_dummy_backend_real_get_is_quiescent;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	FOLKS_BACKEND_CLASS (klass)->get_name = (const gchar* (*) (FolksBackend*)) folks_dummy_backend_real_get_name;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	FOLKS_BACKEND_CLASS (klass)->get_persona_stores = (GeeMap* (*) (FolksBackend*)) folks_dummy_backend_real_get_persona_stores;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_folks_dummy_backend_get_property;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	G_OBJECT_CLASS (klass)->constructor = folks_dummy_backend_constructor;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	G_OBJECT_CLASS (klass)->finalize = folks_dummy_backend_finalize;
#line 1425 "dummy-backend.c"
	/**
	   * Whether this Backend has been prepared.
	   *
	   * See {@link Folks.Backend.is_prepared}.
	   *
	   * @since 0.9.7
	   */
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_DUMMY_BACKEND_IS_PREPARED_PROPERTY, folks_dummy_backend_properties[FOLKS_DUMMY_BACKEND_IS_PREPARED_PROPERTY] = g_param_spec_boolean ("is-prepared", "is-prepared", "is-prepared", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1435 "dummy-backend.c"
	/**
	   * Whether this Backend has reached a quiescent state.
	   *
	   * See {@link Folks.Backend.is_quiescent}.
	   *
	   * @since 0.9.7
	   */
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_DUMMY_BACKEND_IS_QUIESCENT_PROPERTY, folks_dummy_backend_properties[FOLKS_DUMMY_BACKEND_IS_QUIESCENT_PROPERTY] = g_param_spec_boolean ("is-quiescent", "is-quiescent", "is-quiescent", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1445 "dummy-backend.c"
	/**
	   * {@inheritDoc}
	   *
	   * @since 0.9.7
	   */
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_DUMMY_BACKEND_NAME_PROPERTY, folks_dummy_backend_properties[FOLKS_DUMMY_BACKEND_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1453 "dummy-backend.c"
	/**
	   * {@inheritDoc}
	   *
	   * @since 0.9.7
	   */
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), FOLKS_DUMMY_BACKEND_PERSONA_STORES_PROPERTY, folks_dummy_backend_properties[FOLKS_DUMMY_BACKEND_PERSONA_STORES_PROPERTY] = g_param_spec_object ("persona-stores", "persona-stores", "persona-stores", GEE_TYPE_MAP, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 1461 "dummy-backend.c"
}

static void
folks_dummy_backend_instance_init (FolksDummyBackend * self,
                                   gpointer klass)
{
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	self->priv = folks_dummy_backend_get_instance_private (self);
#line 57 "../backends/dummy/lib/dummy-backend.vala"
	self->priv->_is_prepared = FALSE;
#line 58 "../backends/dummy/lib/dummy-backend.vala"
	self->priv->_prepare_pending = FALSE;
#line 59 "../backends/dummy/lib/dummy-backend.vala"
	self->priv->_is_quiescent = FALSE;
#line 1476 "dummy-backend.c"
}

static void
folks_dummy_backend_finalize (GObject * obj)
{
	FolksDummyBackend * self;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, FOLKS_DUMMY_TYPE_BACKEND, FolksDummyBackend);
#line 61 "../backends/dummy/lib/dummy-backend.vala"
	_g_object_unref0 (self->priv->_all_persona_stores);
#line 62 "../backends/dummy/lib/dummy-backend.vala"
	_g_object_unref0 (self->priv->_enabled_persona_stores);
#line 63 "../backends/dummy/lib/dummy-backend.vala"
	_g_object_unref0 (self->priv->_enabled_persona_stores_ro);
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	G_OBJECT_CLASS (folks_dummy_backend_parent_class)->finalize (obj);
#line 1493 "dummy-backend.c"
}

/**
 * A backend which allows {@link FolksDummy.PersonaStore}s and
 * {@link FolksDummy.Persona}s to be programmatically created and manipulated,
 * for the purposes of testing the core of libfolks itself.
 *
 * This backend is not meant to be enabled in production use. The methods on
 * {@link FolksDummy.Backend} (and other classes) for programmatically
 * manipulating the backend's state are considered internal to libfolks and are
 * not stable.
 *
 * This backend maintains two sets of persona stores: the set of all persona
 * stores, and the set of enabled persona stores (which must be a subset of the
 * former). {@link FolksDummy.Backend.register_persona_stores} adds persona
 * stores to the set of all stores. Optionally it also enables them, adding them
 * to the set of enabled stores. The set of persona stores advertised by the
 * backend as {@link Folks.Backend.persona_stores} is the set of enabled stores.
 * libfolks may internally enable or disable stores using
 * {@link Folks.Backend.enable_persona_store},
 * {@link Folks.Backend.disable_persona_store}
 * and {@link Folks.Backend.set_persona_stores}.  The ``register_`` and
 * ``unregister_`` prefixes are commonly used for backend methods.
 *
 * The API in {@link FolksDummy} is unstable and may change wildly. It is
 * designed mostly for use by libfolks unit tests.
 *
 * @since 0.9.7
 */
static GType
folks_dummy_backend_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FolksDummyBackendClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) folks_dummy_backend_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (FolksDummyBackend), 0, (GInstanceInitFunc) folks_dummy_backend_instance_init, NULL };
	GType folks_dummy_backend_type_id;
	folks_dummy_backend_type_id = g_type_register_static (FOLKS_TYPE_BACKEND, "FolksDummyBackend", &g_define_type_info, 0);
	FolksDummyBackend_private_offset = g_type_add_instance_private (folks_dummy_backend_type_id, sizeof (FolksDummyBackendPrivate));
	return folks_dummy_backend_type_id;
}

GType
folks_dummy_backend_get_type (void)
{
	static volatile gsize folks_dummy_backend_type_id__once = 0;
	if (g_once_init_enter (&folks_dummy_backend_type_id__once)) {
		GType folks_dummy_backend_type_id;
		folks_dummy_backend_type_id = folks_dummy_backend_get_type_once ();
		g_once_init_leave (&folks_dummy_backend_type_id__once, folks_dummy_backend_type_id);
	}
	return folks_dummy_backend_type_id__once;
}

static void
_vala_folks_dummy_backend_get_property (GObject * object,
                                        guint property_id,
                                        GValue * value,
                                        GParamSpec * pspec)
{
	FolksDummyBackend * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, FOLKS_DUMMY_TYPE_BACKEND, FolksDummyBackend);
#line 55 "../backends/dummy/lib/dummy-backend.vala"
	switch (property_id) {
#line 55 "../backends/dummy/lib/dummy-backend.vala"
		case FOLKS_DUMMY_BACKEND_IS_PREPARED_PROPERTY:
#line 55 "../backends/dummy/lib/dummy-backend.vala"
		g_value_set_boolean (value, folks_backend_get_is_prepared ((FolksBackend*) self));
#line 55 "../backends/dummy/lib/dummy-backend.vala"
		break;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
		case FOLKS_DUMMY_BACKEND_IS_QUIESCENT_PROPERTY:
#line 55 "../backends/dummy/lib/dummy-backend.vala"
		g_value_set_boolean (value, folks_backend_get_is_quiescent ((FolksBackend*) self));
#line 55 "../backends/dummy/lib/dummy-backend.vala"
		break;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
		case FOLKS_DUMMY_BACKEND_NAME_PROPERTY:
#line 55 "../backends/dummy/lib/dummy-backend.vala"
		g_value_set_string (value, folks_backend_get_name ((FolksBackend*) self));
#line 55 "../backends/dummy/lib/dummy-backend.vala"
		break;
#line 55 "../backends/dummy/lib/dummy-backend.vala"
		case FOLKS_DUMMY_BACKEND_PERSONA_STORES_PROPERTY:
#line 55 "../backends/dummy/lib/dummy-backend.vala"
		g_value_set_object (value, folks_backend_get_persona_stores ((FolksBackend*) self));
#line 55 "../backends/dummy/lib/dummy-backend.vala"
		break;
#line 1579 "dummy-backend.c"
		default:
#line 55 "../backends/dummy/lib/dummy-backend.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 55 "../backends/dummy/lib/dummy-backend.vala"
		break;
#line 1585 "dummy-backend.c"
	}
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

